﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace WindowsFormsApplication4
{
    public partial class Form1 : Form
    {
        private BackgroundWorker worker;

        public Form1()
        {
            InitializeComponent();
            worker = new BackgroundWorker();
            worker.DoWork += new DoWorkEventHandler(worker_DoWork);
            worker.ProgressChanged += new ProgressChangedEventHandler(worker_ProgressChanged);
            worker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(worker_RunWorkerCompleted);
            worker.WorkerReportsProgress = true;
            worker.WorkerSupportsCancellation = true;
        }

        void worker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            if (e.Error != null)
            {
                statusLabel.Text = "Exception occured";
            }
            else if (e.Cancelled)
            {
                statusLabel.Text = "Cancelled";
            }
            else
            {
                statusLabel.Text = "Finished";
            }
        }

        void worker_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            progressBar.Value = e.ProgressPercentage;
            statusLabel.Text = String.Format("Done {0} %", e.ProgressPercentage);
        }

        void worker_DoWork(object sender, DoWorkEventArgs e)
        {
            Random rnd = new Random();
            BackgroundWorker w = sender as BackgroundWorker;
            
            for (int i = 1; i <= 100; i++)
            {
                if (w.CancellationPending)
                {
                    e.Cancel = true;
                    return;
                }
                int r = rnd.Next(0, 100);
                if (r < 2)
                {
                    throw new Exception();
                }
                if (2 <= r && r < 95)
                {
                    Thread.Sleep(50);
                }
                else
                {
                    Thread.Sleep(2000);
                }
                Console.WriteLine(i);
                w.ReportProgress(i);
            }
        }

        private void startButton_Click(object sender, EventArgs e)
        {
            stopButton.Enabled = true;
            startButton.Enabled = false;
            worker.RunWorkerAsync();
        }

        private void stopButton_Click(object sender, EventArgs e)
        {
            stopButton.Enabled = false;
            startButton.Enabled = true;
            worker.CancelAsync();
        }
    }
}
